struct cacheS {
	struct cacheS	*nextP;
	u2T				*stringP;
} stringCacheT;

static cacheT	hashtable[0x4000] = {0};

static cacheT	*leftP;
static int		left = 0;

const u2T
stringCache(const u2T *stringP)
{
	u2T		*P;
	u4T		hash;
	cacheT	*cacheP;

	hash = 0;
	for (P = stringP; c = *P; ++P) {
		hash ^= c;
	}
	hash &= 0x3FFF;
	for (cacheP = hashtable[hash]; cacheP; cacheP = cacheP->nextP) {
		if (!wcscmp(stringP, cacheP->stringP)) {
			return cacheP->stringP;
	}	}
	if (left == 0) {
		left  = 2048;
		leftP = (cacheT *) xmalloc(sizeof(cacheT) * 2048);
	}
	cacheP = leftP + --left;
	cacheP->nextP   = hashtable[hash];
	cacheP->stringP = stringP;
	hashtable[hash] = cacheP;
	return stringP;
}
